from sys import stderr
import pickle

# Load configuration generated by GLA
with open('config.bin', 'rb') as f:
    syncsyms, q0, action, next_state = pickle.load(f)

# Define parse tree data structure
class tree:
    def __init__(self, name, children):
        self.name = name
        self.children = children

    def print(self, indent=0):
        print(indent * ' ' + self.name)
        for child in self.children:
            child.print(indent + 1)

class leaf:
    def __init__(self, line):
        self.line = line

    def print(self, indent=0):
        print(indent * ' ' + self.line)

# Place initial state on stack
stack = [q0]

# Process input
line = input()
while line:
    token, ln, val = line.split(maxsplit=2)

    # Check for syntax errors
    if token not in action[stack[-1]]:
        print("Error at line {}!".format(ln), file=stderr)
        print(" Expected: one of {}".format(list(action[stack[-1]])), file=stderr)
        print(" Got: {} ({})".format(token, val), file=stderr)

        # Skip input until the next synchronization token
        while token not in syncsyms:
            try:
                line = input()
                if not line:
                    break
            except EOFError:
                line = None
                break
            token, ln, val = line.split(maxsplit=2)

        if not line:
            break

        # Discard erroneous stack elements until something can accept the synchronization token
        while token not in action[stack[-1]]:
            stack[-2:] = []

    # Process the new token
    act, *args = action[stack[-1]][token]
    
    if act == 0:
        # Shift action
        nxt, = args
        stack.append(leaf(line))
        stack.append(nxt)
        try:
            line = input()
        except EOFError:
            break
    elif act == 1:
        # Reduce action
        ntsym, prod = args
        
        children = stack[len(stack)-2*len(prod)::2]
        if not children:
            children = [leaf('$')]

        stack[len(stack)-2*len(prod):] = [tree(ntsym, children)]
        stack.append(next_state[stack[-2]][ntsym])
    # Accept action cannot appear here for a valid parser configuration

# Process end-of-input transitions
while True:
    if '#' not in action[stack[-1]]:
        print("Premature end of input!".format(ln), file=stderr)
        print(" Expected: one of {}".format(list(action[stack[-1]])), file=stderr)

        # Discard erroneous stack elements until something can accept the synchronization token
        while '#' not in action[stack[-1]]:
            stack[-2:] = []

    # Process end of input
    act, *args = action[stack[-1]]['#']

    if act == 0:
        # Shift action
        nxt, = args
        stack.append(leaf('$'))
        stack.append(nxt)
    elif act == 1:
        # Reduce action
        ntsym, prod = args

        children = stack[len(stack)-2*len(prod)::2]
        if not children:
            children = [leaf('$')]

        stack[len(stack)-2*len(prod):] = [tree(ntsym, children)]
        stack.append(next_state[stack[-2]][ntsym])
    else:
        # Accept action
        # Stack must have exectly 2 elements for a valid parser configuration
        stack[-2].print()
        break
